function [u] = Zad3 (n,t,p)

% poprzedni wynik u(x,t(i-1))
prev = zeros(n+1,1);

B = zeros(n+1);

% najpierw obliczam macierz B - ona nie bedzie sie zmieniac
% zapisuje sobie wartosc pochodnych: chi1' i chi2'
chi = [-1 1];
% zapisuje sobie wartosc calki od 0 do 1 z chi1*chi2
ch = [1/3 , 1/6 ; 1/6 , 1/3];

for k=1:n
    
    for i=1:2
        
        i1 = k+i-1;
        
        for j=1:2
            
            j1 = k+j-1;
            B(j1, i1) = B(j1, i1) + chi(i)*chi(j)*n*t/p + ch(i,j)/n;
        end
    end   
end    

B(1,1) = B(1,1) + t/p;
B(n+1,n+1) = B(n+1,n+1) - t/p;

punkty = [0:1/n:1];
% obliczenia dla kazdego kroku czasowego
% zapisuje wartosci chi(i)(0) oraz chi(i)(1)
ch = [ 1 , 0 ; 0 , 1 ];
for q=1:p
  
L = zeros(1,n+1);
for k=1:n   
    for i=1:2       
        i1 = k+i-1;
        % calke przyblizam regula Simpsona
        L(i1) = L(i1) + (prev(k)*ch(i,1) + prev(k) + prev(k+1) + prev(k+1)*ch(i,2))/(n*6);
    end   
end   

L(1) = L(1) + t/p;
L(n+1) = L(n+1) + t/p;

% macierze L i B gotowe

% robie pseudo pivoting:
wiersz = zeros(1,n+1);
wektor_pr = L';

for i=1:n
    if B(i,i)==0
        k = n+1;
        while B(k,i)==0
            k = k-1;
        end
        wiersz = B(i,:);
        a = wektor_pr(i,1);
        B(i,:) = B(k,:);
        wektor_pr(i,1) = wektor_pr(k,1);
        B(k,:) = wiersz;
        wektor_pr(k,1) = a;
        k = k-1;
    end
end
    
% przepisuje moja macierz (n+1)x(n+1) do (n+1)x3
macierz = zeros(n+1, 3);
wynik = zeros(n+1,1);

for i=2:n
    macierz(i,1) = B(i,i-1);
    macierz(i,2) = B(i,i);
    macierz(i,3) = B(i,i+1);
end

macierz(1,1) = 0;
macierz(1,2) = B(1,1);
macierz(1,3) = B(1,2);

macierz(n+1,1) = B(n+1, n);
macierz(n+1,2) = B(n+1, n+1);
macierz(n+1,3) = 0;


% eliminacja gaussa dla macierzy (n+1)x3 i wektora prawej strony

wektor_pr(1,1) = wektor_pr(1,1)/macierz(1,2);
macierz(1,:) = macierz(1,:)/macierz(1,2);


for k = 2:n+1
    dzielnik = macierz(k,1)/macierz(k-1,2);
    macierz(k,1) = macierz(k,1) - dzielnik * macierz(k-1,2);
    macierz(k,2) = macierz(k,2) - dzielnik * macierz(k-1,3);
    wektor_pr(k,1) = wektor_pr(k,1) - dzielnik * wektor_pr(k-1,1);
    wektor_pr(k,1) = wektor_pr(k,1)/macierz(k,2);
    macierz(k,:) = macierz(k,:)/macierz(k,2);
end


% podstawienie odwrotne po eliminacji gaussa
wynik(n+1,1) = wektor_pr(n+1,1);
for k = n:-1:1
    wynik(k,1) = wektor_pr(k,1) - macierz(k,3)*wynik(k+1,1);
end

prev = wynik;

plot(punkty, wynik);
axis([0 1 0 500]);
drawnow;
pause(t*2/p);

end

end
